


#if !defined (__ELECTRON_H)

#define __ELECTRON_H

#include "quark.h"

/* *************************************************************
   This is the camera class
************************************************************* */
class electron : public quark {

   protected:
      vector3f vup, vpn;

   public:
      // superclass
      int  query_whatami() { return OBJECT_ELECTRON; }
      int  query_whatwasi(int type);
      int  parse(FILE *infile, char *token);
      void preprocess(void *data);

      // quark
      void setup();

      // electron
      electron();
      virtual ~electron() {}
};


/* *************************************************************
************************************************************* */
class electron_loader : public quark_loader {

   public:
      superclass *make_object() { return new electron; }
      electron_loader() {
         object_name = TOKEN_ELECTRON_STR;
         alias_name = TOKEN_CAMERA_STR;
      }

      virtual ~electron_loader() {}
};



#endif

